/***********************************************************************************
	
	Projekt:	Ein Betriebsystem fr AVR-8Bit Mikrocontroller
	Datei:		mutex.S
	Autor:		Mark Prediger
	Datum:		07.10.2008
	Copyright:	Mark Prediger, mark_prediger@hotmail.de
	
	
	Beschreibung: 
		Funktionsdefinitionen fr die Verwendung von Mutex
	
	Funktionsweise:
		siehe Header mutex.h
	
	Dieses Programm darf frei kopiert und gendert werden, solange
	es nicht kommerziell verwendet wird. Die kommerzielle Nuztung bentigt
	meine Erlaubnis.

***********************************************************************************/

#include "avr/io.h"
#include "mutex.h"

.global LockMutex	// void LockMutex(Mutex*);	
.func LockMutex
LockMutex:
	movw ZL, 24
mutex_lock_wait:
	cli
	ld 18, Z
	cpi 18, MUTEX_STATE_UNLOCKED
	breq lock_mutex_lock	// while(mutex->state == LOCKED) SwitchToThread()
	sei
	call SwitchToThread
	rjmp mutex_lock_wait

lock_mutex_lock:
	ldi 18, MUTEX_STATE_LOCKED
	sei
	st Z, 18	// mutex->state = LOCKED
	
	ret
.endfunc

.global TryLockMutex	// int TryLockMutex(Mutex*);	
.func TryLockMutex
TryLockMutex:
	movw ZL, 24
mutex_trylocklock_wait:
	in 19, _SFR_IO_ADDR(SREG)
	cli
	ld 18, Z
	cpi 18, MUTEX_STATE_UNLOCKED
	breq trylocklock_mutex_lock	// while(mutex->state == UNLOCKED) LockMutex else return -1
	
	out _SFR_IO_ADDR(SREG), 19
	ldi 24, lo8(-1)
	ldi 25, hi8(-1)
	ret

trylocklock_mutex_lock:
	ldi 18, MUTEX_STATE_LOCKED
	out _SFR_IO_ADDR(SREG), 19
	st Z, 18	// mutex->state = LOCKED
	
	clr 24
	clr 25
	ret
.endfunc
