/***********************************************************************************

	Projekt:	AVR-OS - Ein Betriebsystem fr AVR-8Bit Mikrocontroller
	Datei:		os.cpp
	Autor:		Mark Prediger
	Datum:		08.02.2009
	Copyright:	Mark Prediger, mark_prediger@hotmail.de
	Lizenz:		GNU GPL
	
	Dieses Programm darf frei kopiert und gendert werden, solange
	es nicht kommerziell verwendet wird. Die kommerzielle Nuztung bentigt
	meine Erlaubnis.
	
	Beschreibung:
		Variablendefinitionen fr den Betriebssystem-Kern und die 
		Standard Callback Prozedur fr Nachrichten

	Funktionsweise:
		Es werden lediglich Variablen fr Threads, Messages und Timer angelegt.

***********************************************************************************/

#include <avr/pgmspace.h>
#include "os.h"

volatile HTHREAD _thread_fifo[MAX_THREADS];	// FIFO for waiting treads
volatile HTHREAD *volatile _in_index = _thread_fifo, *volatile _out_index = _thread_fifo;	// in and out pointer for _thread_fifo
volatile HTHREAD _active_thread;	// tid of the active thread	(-1: idle)
volatile THREAD _main_thread;		// Hauptthread

volatile Message message_fifo[MESSAGE_FIFO_SIZE];
volatile Message *volatile message_in_index = message_fifo,
				 *volatile message_out_index = message_fifo;

volatile __TIMER _timers[MAX_TIMERS];
volatile __TIMER* volatile _timerindex = _timers;

void(* volatile system_def_proc)(int16_t, int16_t) = SystemDefProc;


void SystemDefProc(int16_t msg, int16_t param) // Standard Callback Prozedur fr Nachrichten
{
	switch(msg)
	{
		default:
			return;
	}
}
